.386                                                ;processor instruction set
.model flat, stdcall                                ;memory model
option casemap :none                                ;case sensitive code

;------------------------Include Files And Libaraies--------------------------;
include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\comctl32.inc
include \masm32\include\shlwapi.inc
include \masm32\include\ole32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\shlwapi.lib
includelib \masm32\lib\ole32.lib

;-------------------------Added equates and structures------------------------;
LVIF_GROUPID equ 100h
LVGF_HEADER equ 1h 
LVGF_ALIGN   equ 8h 
LVGF_GROUPID equ 10h 
LVGA_HEADER_LEFT equ 1h 
LVGA_HEADER_CENTER equ 2h 
LVGA_HEADER_RIGHT  equ 4h
LVM_ENABLEGROUPVIEW equ LVM_FIRST+157
LVM_INSERTGROUP	equ LVM_FIRST + 145 

LVGROUP STRUCT
cbSize			DWORD	?	
imask			DWORD	?	;<--- Note mask reserved word... using imask
pszHeader		DWORD	?
cchHeader		DWORD	?
pszFooter		DWORD	?
cchFooter		DWORD	?
iGroupId		DWORD	?
stateMask		DWORD	?
state			DWORD	?
uAlign			DWORD	?
LVGROUP ends
;-------------------------Local Procedures Predefined-------------------------;
WinMain 			PROTO :DWORD,:DWORD,:DWORD,:DWORD
WndProc 			PROTO :DWORD,:DWORD,:DWORD,:DWORD
CreateWinMainGUI	PROTO :DWORD
;-------------------------Application Data Section----------------------------;
.data
	szAppName			db	"BitFusion",0
	szClassName 		db	"BitFusion.MainWindow",0
	szBitFusionMenu		db	"Select the operation type",0
	szMenuItem1			db	"Create a new archive",0
	szArchiveMenu		db	"Archive Operations",0
	LISTVIEWCLASSNAME	db	"SysListView32",0
	
	g_hWnd          	dd  0
	g_hInstance			dd	0
	g_hWndListView		dd	0
.data?
	hInstance			HINSTANCE	?
	CommandLine			LPSTR		?

;-------------------------Application Entry Point-----------------------------;
.code
start:
	invoke GetModuleHandle, NULL
	mov g_hInstance,eax
	invoke GetCommandLine
	mov CommandLine,eax
	invoke WinMain,g_hInstance,NULL,CommandLine,SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc	hInst:HINSTANCE,
				hPrevInst:HINSTANCE,
				CmdLine:LPSTR,
				CmdShow:DWORD

	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND

	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  g_hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_3DFACE+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET szClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	invoke RegisterClassEx, addr wc
	invoke CreateWindowEx,
		   NULL,\
		   ADDR szClassName,\
		   ADDR szAppName,\
           WS_OVERLAPPEDWINDOW,\
           CW_USEDEFAULT,\
           CW_USEDEFAULT,\
           CW_USEDEFAULT,\
           CW_USEDEFAULT,\
           NULL,\
           NULL,\
           hInst,\
           NULL
    mov hwnd,eax
	invoke ShowWindow,hwnd,SW_SHOWNORMAL
	invoke UpdateWindow,hwnd
	.WHILE TRUE
		invoke GetMessage,ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage,ADDR msg
		invoke DispatchMessage,ADDR msg
	.ENDW
	mov eax,msg.wParam
	ret
WinMain endp
WndProc proc	hWnd:HWND,
				uMsg:UINT,
				wParam:WPARAM,
				lParam:LPARAM

	.IF	uMsg==WM_CREATE
		invoke CreateWinMainGUI,hWnd
	.ELSEIF uMsg==WM_SIZE
	.ELSEIF uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.ENDIF
	xor eax,eax
	ret
WndProc endp
CreateWinMainGUI proc	hWndOwner:HANDLE

	LOCAL	iccex:INITCOMMONCONTROLSEX
	LOCAL	lvi:LVITEM
	LOCAL	lvg:LVGROUP
	LOCAL	rc:RECT
	LOCAL	pwsz:DWORD
	
	mov iccex.dwSize,sizeof INITCOMMONCONTROLSEX
	mov iccex.dwICC,ICC_BAR_CLASSES or ICC_LISTVIEW_CLASSES
	invoke InitCommonControlsEx,ADDR iccex
	invoke GetClientRect,hWndOwner,ADDR rc
	
	;Using ListView Tile View as Menu Object...
	invoke CreateWindowEx,\
			NULL,\
			ADDR LISTVIEWCLASSNAME,\
			NULL,\
			WS_CHILD or LVS_ICON or\
			WS_VISIBLE,\
			NULL,\
			NULL,\
			300,\;<----- blue line approximatly 300 units long
			rc.bottom,\
			hWndOwner,\
			NULL,\
			g_hInstance,\
			NULL
	mov g_hWndListView,eax
	invoke SendMessage,eax,LVM_ENABLEGROUPVIEW,TRUE,NULL
	invoke RtlZeroMemory,ADDR lvi,sizeof LVITEM
	invoke RtlZeroMemory,ADDR lvg,sizeof LVGROUP
	mov lvg.cbSize,sizeof LVGROUP
	mov lvg.imask,LVGF_ALIGN or LVGF_GROUPID or LVGF_HEADER
	invoke SHStrDup,OFFSET szBitFusionMenu,ADDR pwsz
	mov eax,pwsz
	mov lvg.pszHeader,eax
	mov lvg.uAlign,LVGA_HEADER_LEFT
	mov lvg.iGroupId,NULL
	invoke SendMessage,g_hWndListView,LVM_INSERTGROUP,-1,ADDR lvg
	invoke CoTaskMemFree,pwsz
	mov lvg.iGroupId,NULL
	invoke SHStrDup,OFFSET szArchiveMenu,ADDR pwsz
	mov eax,pwsz
	mov lvg.pszHeader,eax
	invoke SendMessage,g_hWndListView,LVM_INSERTGROUP,-1,ADDR lvg
	invoke CoTaskMemFree,pwsz
	
	mov lvi.imask,LVIF_TEXT or LVIF_GROUPID
	mov lvi.pszText,offset szMenuItem1
	mov lvi.iItem,0
	mov lvi.iSubItem,0
	mov lvi.cchTextMax,sizeof szMenuItem1
	mov lvi.iGroupId,NULL
	
	invoke SendMessage,g_hWndListView,LVM_INSERTITEM,NULL,ADDR lvi	

	RET
CreateWinMainGUI EndP

end start